#if !defined(AFX_BACKPYTHON_H__81C0EC5C_DB4E_416B_8EA6_BB3F052B5166__INCLUDED_)
#define AFX_BACKPYTHON_H__81C0EC5C_DB4E_416B_8EA6_BB3F052B5166__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BackPython.h : header file
//

#include "Python.h"
#include <afxmt.h>					// MFC multithread classes (pour le CCriticalSection)


const int WM_PYTHON_QUIT = (WM_USER+1000);


// Used to stored current decompile/compile status
struct CStatBatch {
	BOOL done;						// TRUE if all file done or in case of error (see isErr)
	int curFileNbr;				// Current file number
	int totalFile;				// Total number of file
	CString curFilename;	// Name of current file
	CString filenameToDo;	// List of filename that still need to be (de)compile (comma separeted)
	CString sourceDir;		// Directory in which PYC file are stored
	BOOL isErr;						// TRUE if 'curFilename' generated an error
	CString errMsg;				// If 'isErr', error message generated by python
	BOOL decompyle;				// TRUE for decopylation, FALSE for compilation
};


/////////////////////////////////////////////////////////////////////////////
// CBackPython thread

class CBackPython : public CWinThread
{
	DECLARE_DYNCREATE(CBackPython)
public:
	CBackPython();           // protected constructor used by dynamic creation
	virtual ~CBackPython();

// Attributes
public:

// Operations
public:
	BOOL StartPython(CString &errMsg);
	void StopPython();
	BOOL IsPythonStarted();

	BOOL StartBatch(CString sourceDir, CString fileList, BOOL checkDate, BOOL isDecompyle);
	void StopBatch();
	void GetBatchStatus(CStatBatch &data);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBackPython)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CBackPython)
	//}}AFX_MSG

	afx_msg void QuitThread( UINT wParam, LONG lParam);
	afx_msg void StartPythonMsg( UINT wParam, LONG lParam);
	afx_msg void StopPythonMsg( UINT wParam, LONG lParam);
	afx_msg void BatchMsg( UINT wParam, LONG lParam);


	DECLARE_MESSAGE_MAP()

private:
	CPython *m_pythonObj;

	CEvent m_EventCmdDone;			// End of command in second thread
	CEvent m_EventDecompyle;		// End of the decompyle command


	BOOL m_resultStart;
	CString m_errStart;

	
	CCriticalSection m_lockDataBatch;
	CStatBatch m_dataBatch;
	BOOL m_stopBatch;

};

extern CBackPython *g_backPython;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BACKPYTHON_H__81C0EC5C_DB4E_416B_8EA6_BB3F052B5166__INCLUDED_)
