// ConfigDiag.cpp : implementation file
//

#include "stdafx.h"
#include "UruPython3.h"
#include "ConfigDiag.h"
#include "FolderSelect.h"
#include "BackPython.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigDiag dialog


CConfigDiag::CConfigDiag(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigDiag::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigDiag)
	m_uruPath = _T("");
	m_uruExe = _T("");
	m_uruExeParam = _T("");
	//}}AFX_DATA_INIT
}


void CConfigDiag::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigDiag)
	DDX_Text(pDX, IDC_URUPATH, m_uruPath);
	DDX_CBString(pDX, IDC_URUEXE, m_uruExe);
	DDX_Text(pDX, IDC_PARAMEXE, m_uruExeParam);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigDiag, CDialog)
	//{{AFX_MSG_MAP(CConfigDiag)
	ON_BN_CLICKED(IDC_SELPATHURU, OnSelPathUru)
	ON_BN_CLICKED(IDC_DEFPARAM, OnDefParam)
	ON_BN_CLICKED(IDC_FETCHDLL, OnFetchDLL)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigDiag message handlers

void CConfigDiag::OnSelPathUru() 
{
	CFolderSelect mySelect;

	mySelect.m_dirName = m_uruPath;
	mySelect.m_MsgBrowse = _T("");
	if (mySelect.DoModal(this) == IDOK) {
		m_uruPath = mySelect.m_dirName;
		GetDlgItem(IDC_URUPATH)->SetWindowText(m_uruPath);
	}
}

int CConfigDiag::DoModal() 
{
	// Read variable from global config structure
	m_uruPath = g_config.uruPath;
	m_uruExe = g_config.uruExe;
	m_uruExeParam = g_config.uruExeParam;
	
	int result = CDialog::DoModal();

	if (result == IDOK) {
		// Save variable in global structure
		if (m_uruPath != g_config.uruPath) {
			// Recreate PAK and Src folder based on new Uru folder
			g_config.uruPath = m_uruPath;
			g_config.pakFilename = g_config.uruPath + _T("Python\\Python.pak");
			g_config.srcFolder = g_config.uruPath + _T("Python\\Src\\");
		}
		g_config.uruExe = m_uruExe;
		g_config.uruExeParam = m_uruExeParam;


	}
	
	return result;
}

BOOL CConfigDiag::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// Set default command line parameter based on 'uruExe'
void CConfigDiag::OnDefParam() 
{
	CString curProgName;
	GetDlgItem(IDC_URUEXE)->GetWindowText(curProgName);
	curProgName.TrimLeft();
	curProgName.TrimRight();
	curProgName.MakeUpper();
	CString defParam;
	if (curProgName == _T("URUSETUP.EXE"))
		defParam = _T("SinglePlayer");
	else if (curProgName == _T("URUEXPLORER.EXE"))
		defParam = _T("-iinit To_Dni");

	GetDlgItem(IDC_PARAMEXE)->SetWindowText(defParam);
}

// Try to fetch the required file from the Uru directory.  Overwrite the one currently in the UruPython folder
void CConfigDiag::OnFetchDLL() 
{
	// Make sure not link created with the DLL
	g_backPython->StopPython();

	// Try to copy the 'cypython22.dll' file
	CString filename = m_uruPath + g_config.pythonDLL;
	CFileFind finder;
	BOOL fileExist = finder.FindFile(filename);
	finder.Close();

	if (!fileExist) {
		CString msg;
		msg.Format(_T("Unable to locate file %s.  Make sure 'Uru Folder' is set properly."), g_config.pythonDLL);
		MessageBox(msg, _T("File not found"), MB_ICONERROR);
		return;
	}

	CString destFilename = g_config.appPath + g_config.pythonDLL;
	if (!CopyFile(filename, destFilename, FALSE)) {
		CString msg;
		msg.Format(_T("Unable to copy file %s to [%s]."), g_config.pythonDLL, destFilename);
		MessageBox(msg, _T("Copy file problem"), MB_ICONERROR);
		return;
	}

	// Try to copy the '_sre.pyc' file
	const TCHAR *const SreDLL = _T("python\\system\\_sre.pyd");
	filename = m_uruPath + SreDLL;
	fileExist = finder.FindFile(filename);
	finder.Close();

	if (!fileExist) {
		CString msg;
		msg.Format(_T("Unable to locate file %s.  Make sure 'Uru Folder' is set properly."), SreDLL);
		MessageBox(msg, _T("File not found"), MB_ICONERROR);
		return;
	}

	destFilename = g_config.appPath + _T("_sre.pyd");
	if (!CopyFile(filename, destFilename, FALSE)) {
		CString msg;
		msg.Format(_T("Unable to copy file %s to [%s]."), SreDLL, destFilename);
		MessageBox(msg, _T("Copy file problem"), MB_ICONERROR);
		return;
	}

	MessageBox(_T("Copy successfull"), _T("Information"), MB_ICONEXCLAMATION);
}
