// FolderSelect.cpp: implementation of the CFolderSelect class.
//
//////////////////////////////////////////////////////////////////////

// Allows selection of a folder

#include "stdafx.h"
#include "FolderSelect.h"

#include <shlobj.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFolderSelect::CFolderSelect()
{
	m_dirName.Empty();
	m_MsgBrowse.Empty();
}

CFolderSelect::~CFolderSelect()
{

}

int CFolderSelect::DoModal(CDialog *parentDialog /*= NULL*/)
{
	HWND handleWin = NULL;
	if (parentDialog) {
		handleWin = parentDialog->m_hWnd;
	}

	LPMALLOC shellAlloc;
	HRESULT resultat = SHGetMalloc(&shellAlloc);
	if (!SUCCEEDED(resultat)) {
		return IDCANCEL;
	}


	// Adjust parameters for the browsing box
	BROWSEINFO myData;

	myData.hwndOwner = handleWin;
	myData.pidlRoot = NULL;
	myData.pszDisplayName = NULL;
	myData.lpszTitle = m_MsgBrowse.GetBuffer(1);
	myData.ulFlags = BIF_RETURNONLYFSDIRS | BIF_DONTGOBELOWDOMAIN; // | BIF_STATUSTEXT;
	myData.lpfn = BrowseCallbackProc;
	myData.lParam = (LPARAM)this;
	myData.iImage = 0;

	// Display box and wait for user inputs
	int funcResult = IDCANCEL;
	LPITEMIDLIST myResult = SHBrowseForFolder(&myData);
	if (myResult) {
		// Store choice in m_dirname
		TCHAR szDir[MAX_PATH];
		if (SHGetPathFromIDList(myResult ,szDir)) {
			m_dirName = szDir;
			m_dirName += _T("\\");
			funcResult = IDOK;
		}

		shellAlloc->Free(myResult);
	}

	// Clean things up
	m_MsgBrowse.ReleaseBuffer();

	shellAlloc->Release();
	
	return funcResult;
}

// used to set default folder first time browse box is displayed
int CALLBACK CFolderSelect::BrowseCallbackProc(HWND hwnd,UINT uMsg,LPARAM lp, LPARAM pData) {
	CFolderSelect *myDataPtr = (CFolderSelect *)pData;
	if (!myDataPtr)
		return 0;
	
	// Get rid of the last backslash in m_dirName
	CString dirName = myDataPtr->m_dirName;
	if (!dirName.IsEmpty()) {
		if (dirName.Right(1) == _T("\\"))
			dirName.Delete(dirName.GetLength() - 1);
	}


	switch(uMsg) {
		case BFFM_INITIALIZED: {
			if (!dirName.IsEmpty()) {
				// WParam is TRUE since you are passing a path.
				// It would be FALSE if you were passing a pidl.
				SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)(dirName.GetBuffer(1)));
				dirName.ReleaseBuffer();
			}
			break;
		}
		case BFFM_SELCHANGED: {
			// Set the status window to som text (flag BIF_STATUSTEXT must be include in the BROWSEINFO)
			SendMessage(hwnd,BFFM_SETSTATUSTEXT,0,(LPARAM)(dirName.GetBuffer(1)));
			dirName.ReleaseBuffer();
			break;
		}
		default:
			break;
	}
	return 0;
}
