// PakFiles.cpp : implementation file
//

#include "stdafx.h"
#include "urupython3.h"
#include "PakFilesDlg.h"
#include "BackPython.h"
#include "FolderSelect.h"
#include "Progress.h"
#include "ErrDecomp.h"
#include "SelectFile.h"
#include "FilePak.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPakFilesDlg dialog


CPakFilesDlg::CPakFilesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPakFilesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPakFilesDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPakFilesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPakFilesDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP

	DDX_Check(pDX, IDC_COMPILE, g_config.compile);
	DDX_Check(pDX, IDC_CHECKDATE, g_config.compareDate);
	DDX_Check(pDX, IDC_RUNURU, g_config.runUru);
}



BEGIN_MESSAGE_MAP(CPakFilesDlg, CDialog)
	//{{AFX_MSG_MAP(CPakFilesDlg)
	ON_BN_CLICKED(IDC_SELSOURCE, OnSelSource)
	ON_BN_CLICKED(IDC_SELFILE, OnSeFile)
	ON_BN_CLICKED(IDC_SELPAK, OnSelPak)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Return TRUE if 'filetitle' is in 'listFile' (a comma separated list of file)
BOOL CPakFilesDlg::IsFileInStr(CString filetitle, CString listFile)
{
	filetitle.TrimLeft();
	filetitle.TrimRight();
	filetitle.MakeUpper();

	listFile.TrimLeft();
	listFile.TrimRight();
	listFile.MakeUpper();

	if (filetitle.IsEmpty() || listFile.IsEmpty())
		return FALSE;

	int lengthFile = filetitle.GetLength();
	int lengthList = listFile.GetLength();
	int posStr = listFile.Find(filetitle);
	if (posStr < 0)
		return FALSE;

	do {
		if (posStr + lengthFile > lengthList)
			return FALSE;

		// There should be a comma after the name except if it's the end of the list
		if ((posStr + lengthFile == lengthList) || (listFile[posStr + lengthFile] == _T(','))) {
			// Now check for the comma at the beginning of the string (or it's the first character of the string)
			if ((posStr == 0) || (listFile[posStr - 1] == _T(',')))
				return TRUE;
		}

		posStr = listFile.Find(filetitle, posStr + 1);
	} while (posStr >= 0);

	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// CPakFilesDlg message handlers


BOOL CPakFilesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	GetDlgItem(IDC_SOURCE)->SetWindowText(g_config.srcFolder);
	GetDlgItem(IDC_PAKFILE)->SetWindowText(g_config.pakFilename);

	// By default, select all PYC ans PY file in the source folder
	m_listFilename.Empty();

	CFileFind finder;
	CString pattern = g_config.srcFolder + _T("\\*.PYC"); 
	BOOL isFile = finder.FindFile(pattern);
	while (isFile) {
		isFile = finder.FindNextFile();

		if (!m_listFilename.IsEmpty())
			m_listFilename += _T(',');
		m_listFilename += finder.GetFileTitle();
	}
	finder.Close();
	

	pattern = g_config.srcFolder + _T("\\*.PY"); 
	isFile = finder.FindFile(pattern);
	while (isFile) {
		isFile = finder.FindNextFile();
		if (!IsFileInStr(finder.GetFileTitle(), m_listFilename)) {
			if (!m_listFilename.IsEmpty())
				m_listFilename += _T(',');
			m_listFilename += finder.GetFileTitle();
		}
	}
	finder.Close();

	
	DisplayFileList();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPakFilesDlg::OnSelSource() 
{
	CString curFolder;
	GetDlgItem(IDC_SOURCE)->GetWindowText(curFolder);

	CFolderSelect mySelect;

	mySelect.m_dirName = curFolder;
	mySelect.m_MsgBrowse = _T("");
	if (mySelect.DoModal(this) == IDOK) {
		g_config.srcFolder = mySelect.m_dirName;
		GetDlgItem(IDC_SOURCE)->SetWindowText(g_config.srcFolder);
	}
}

void CPakFilesDlg::DisplayFileList()
{
	CString msg;
	if (m_listFilename.IsEmpty())
		msg = _T("(None)");
	else {
		int nbrFile = CountComma(m_listFilename) + 1;
		if (nbrFile == 1)
			msg = m_listFilename;
		else
			msg.Format(_T("(%d files selected)"), nbrFile);
	}

	GetDlgItem(IDC_FILES)->SetWindowText(msg);
}

void CPakFilesDlg::OnSeFile() 
{
	CSelectFile mySelect;
	GetDlgItem(IDC_SOURCE)->GetWindowText(mySelect.m_sourceDir);
	mySelect.m_fileList = m_listFilename;
	mySelect.m_mergePY = TRUE;

	// Make sure there is at least one PYC file
	CFileFind finder;
	CString pattern = mySelect.m_sourceDir + _T("\\*.PYC"); 
	BOOL isFilePYC = finder.FindFile(pattern);
	finder.Close();
	pattern = mySelect.m_sourceDir + _T("\\*.PY"); 
	BOOL isFilePY = finder.FindFile(pattern);

	if (!isFilePYC && !isFilePY) {
		MessageBox(_T("There is no PYC or PY file in the selected folder."), _T("Error"), MB_ICONERROR);
		return;
	}

	if (mySelect.DoModal() != IDOK)
		return;

	m_listFilename = mySelect.m_fileList;
	DisplayFileList();
}

void CPakFilesDlg::OnSelPak() 
{
	CString startPath;
	GetDlgItem(IDC_PAKFILE)->GetWindowText(startPath);

	CFileDialog myOpenFile(FALSE, _T("pak"), startPath, OFN_NOREADONLYRETURN | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, 
													_T("PAK file (*.pak)|*.pak|All (*.*)|*.*||"), this);

	if (myOpenFile.DoModal() != IDOK)
		return;

	g_config.pakFilename = myOpenFile.GetPathName();
	GetDlgItem(IDC_PAKFILE)->SetWindowText(g_config.pakFilename);
}

void CPakFilesDlg::OnOK() 
{
	CString sourceFolder;
	GetDlgItem(IDC_SOURCE)->GetWindowText(sourceFolder);

	CString outFile;
	GetDlgItem(IDC_PAKFILE)->GetWindowText(outFile);

	if (m_listFilename.IsEmpty()) {
		MessageBox(_T("You must select at least one PYC file"), _T("Error"), MB_ICONERROR);
		return;
	}

	// Fetch checkbox
	if (!UpdateData())
		return;

	// Make sure Python interpreter is started if compilation required
	if (g_config.compile) {
		if (!g_backPython->IsPythonStarted()) {
			CString msgErr;
			if (!g_backPython->StartPython(msgErr)) {
				CString msg;
				msg.Format(_T("Cannot compile because unable to start python => [%s].  Press Config and Fetch DLL if not done yet."));
				MessageBox(msg, _T("Error"), MB_ICONERROR);
				return;
			}
		}

		// Keep only filename for which there is a PY file
		CString filelist = m_listFilename;
		CString curFilename, fullName, fileListPY;
		CFileFind finder;
		BOOL isFile;
		do {
			// Extract next filename
			int posComma = filelist.Find(_T(','));
			if (posComma >= 0)
				curFilename = filelist.Left(posComma);
			else
				curFilename = filelist;

			curFilename.TrimLeft();
			curFilename.TrimRight();

			// Check if file exist
			fullName = sourceFolder + curFilename + _T(".py");
			isFile = finder.FindFile(fullName);
			finder.Close();
			
			// Add it to the list if found
			if (isFile) {
				if (!fileListPY.IsEmpty())
					fileListPY += _T(',');
				fileListPY += curFilename;
			}

			// Extract from the list of file the last filename processed 
			if (posComma >= 0)
				filelist = filelist.Mid(posComma + 1);
			else
				filelist.Empty();

			filelist.TrimLeft();
			filelist.TrimRight();
		} while (!filelist.IsEmpty());

		if (!fileListPY.IsEmpty()) {
			int nbrErr = 0, nbrGood = 0;
			do {
				// Try to start compilation
				if (!g_backPython->StartBatch(sourceFolder, fileListPY, g_config.compareDate, FALSE)) {
					MessageBox(_T("Unable to start compilation."), _T("Error"), MB_ICONERROR);
					return;
				}

				// Display progress dialog
				CProgress myDiag;
				if (myDiag.DoModal() != IDOK)
					return;		// User cancel operation
				
				// Fetch the result of compilation
				CStatBatch data;
				g_backPython->GetBatchStatus(data);
				nbrGood += data.curFileNbr;

				if (data.isErr) {
					// Display error message and wait for user answer
					nbrGood--;
					nbrErr++;
					CErrDecomp myDiagErr;
					myDiagErr.m_decompyle = FALSE;
					myDiagErr.m_filename = data.curFilename;
					myDiagErr.m_folderSource = data.sourceDir;
					myDiagErr.m_errMsg = data.errMsg;
					if (myDiagErr.DoModal() != IDOK)
						return;

					if (!myDiagErr.m_retryCompile) {
						// Get rid of last filename and restart compilation
						fileListPY = data.filenameToDo;
						int posComma = fileListPY.Find(_T(','));
						if (posComma >= 0)
							fileListPY = fileListPY.Mid(posComma + 1);
						else
							fileListPY.Empty();
					} else
						nbrErr--;

					if (!fileListPY.IsEmpty())
						data.done = FALSE;			// Continue the while for the next file
				}
				

				if (data.done) {
					if (nbrErr > 0) {
						CString msg;
						msg.Format(_T("%d files compile successfully (%d error)."), nbrGood, nbrErr);
						MessageBox(msg, _T("Information"), MB_ICONEXCLAMATION);
						
						MessageBox(_T("PYC file NOT pack together because of compilation error."), _T("Error"), MB_ICONERROR);
						return;
					}
					break;
				}
			} while (1);
		}
	}


	// Make sure that the PYC file exist (it's possible to select a PY file without asking for compilation)
	CWaitCursor myWait;
	CString tempList = m_listFilename;
	CString curFilename, fullName;
	CFileFind finder;
	int nbrFileToPack = 0;
	do {
		// Extract next filename
		int posComma = tempList.Find(_T(','));
		if (posComma >= 0)
			curFilename = tempList.Left(posComma);
		else
			curFilename = tempList;

		curFilename.TrimLeft();
		curFilename.TrimRight();
		fullName = sourceFolder + curFilename + _T(".pyc");

		if (!finder.FindFile(fullName)) {
			CString msg;
			msg.Format(_T("File %s is not yet compile (the PYC file does not exist)"), curFilename);
			MessageBox(msg, _T("Error"), MB_ICONERROR);
			return;
		} else
			nbrFileToPack++;

		// Extract from the list of file the last filename processed 
		if (posComma >= 0)
			tempList = tempList.Mid(posComma + 1);
		else
			tempList.Empty();

		tempList.TrimLeft();
		tempList.TrimRight();
	} while (!tempList.IsEmpty());

	// Now pack all PYC file together
	CString errMsg;
	int nbrFilePak;
	
	if (!g_filePak.pakPython(outFile, sourceFolder, m_listFilename, nbrFilePak, errMsg)) {
		CString msg;
		msg.Format(_T("Unable to pack file together [%s]"), errMsg);
		MessageBox(msg, _T("Error"), MB_ICONERROR);
		return;
	}
	if (nbrFilePak != nbrFileToPack) {
		MessageBox(_T("Unable to pack all file together (count mismatch)"), _T("Error"), MB_ICONERROR);
		return;
	}

	if (g_config.runUru) {
		// Try to start Uru
		CString appName = g_config.uruPath + g_config.uruExe + _T(" ") + g_config.uruExeParam;
		STARTUPINFO startInfo;
		memset(&startInfo, 0, sizeof(STARTUPINFO));
		startInfo.cb = sizeof(STARTUPINFO);
		PROCESS_INFORMATION procInfo;

		BOOL isStarted = CreateProcess(NULL, appName.GetBuffer(1000), NULL, NULL, FALSE, 0, NULL, g_config.uruPath, &startInfo, &procInfo);
		appName.ReleaseBuffer();

		if (!isStarted) {
			DWORD error = GetLastError();
			MessageBox(_T("All files pack sucessfully but unable to start Uru"), _T("Information"), MB_ICONEXCLAMATION);
		}
	} else {
		CString msg;
		msg.Format(_T("%d files pack successfully"), nbrFilePak);
		MessageBox(msg, _T("Information"), MB_ICONEXCLAMATION);
	}

	CDialog::OnOK();
}
