// Python.h: interface for the CPython class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PYTHON_H__42B37617_72D1_4E20_9772_5018BD51AA96__INCLUDED_)
#define AFX_PYTHON_H__42B37617_72D1_4E20_9772_5018BD51AA96__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CPython  
{
public:
	CPython();
	virtual ~CPython();

	BOOL OpenLink(CString &errMsg);
	void CloseLink();

	BOOL IsInit();
	CString GetOutput();
	BOOL Decompyle(CString filenameIn, CString filenameOut, CString &msg);
	BOOL Compile(CString filenameIn, CString &msg);


private:
	HINSTANCE m_hDLL;

	typedef struct _object {
		int ob_refcnt;
		char *object;
	} PyObject;

	struct PycStringIO_CAPI {
  
	 /* Read a string from an input object.  If the last argument
			is -1, the remainder will be read.
			*/
		int(*cread)(PyObject *, char **, int);

	 /* Read a line from an input object.  Returns the length of the read
			line as an int and a pointer inside the object buffer as char** (so
			the caller doesn't have to provide its own buffer as destination).
			*/
		int(*creadline)(PyObject *, char **);

		/* Write a string to an output object*/
		int(*cwrite)(PyObject *, char *, int);

		/* Get the output object as a Python string (returns new reference). */
		PyObject *(*cgetvalue)(PyObject *);

		/* Create a new output object */
		PyObject *(*NewOutput)(int);

		/* Create an input object from a Python string
			 (copies the Python string reference).
			 */
		PyObject *(*NewInput)(PyObject *);

		/* The Python types for cStringIO input and output objects.
			 Note that you can do input on an output object.
			 */
//		PyTypeObject *InputType, *OutputType;

	};


	typedef void (__cdecl* Py_InitializeType)(void);
	typedef int (__cdecl* Py_IsInitializedType)(void);
	typedef void (__cdecl* Py_FinalizeType)(void);
	typedef int (__cdecl* PyRun_SimpleStringType)(const char *);
	typedef void (__cdecl* Py_SetProgramNameType)(char *);
	typedef PyObject * (__cdecl* PyImport_ImportModuleType)(char *name);
	typedef PyObject * (__cdecl* PyModule_GetDictType)(PyObject *module);
	typedef int (__cdecl* PyDict_SetItemStringType)(PyObject *dict, char *key, PyObject *val);
	typedef PyObject * (__cdecl* PyObject_GetAttrStringType)(PyObject *object, char *attr_name);
	typedef void * (__cdecl* PyCObject_AsVoidPtrType)(PyObject *object);
	typedef int (__cdecl* PyObject_AsCharBufferType)(PyObject *object, char **buffer, int *buffer_len);
	typedef PyObject * (__cdecl* PyString_FromStringType)(const char *data);
	typedef PyObject * (__cdecl* PyList_NewType)(int size);
	typedef int (__cdecl* PyList_AppendType)(PyObject *list, PyObject *object);
	typedef PyObject * (__cdecl* PyObject_CallMethodType)(PyObject *object, char *method, char *arg, ...);

	Py_InitializeType Py_Initialize;
	Py_IsInitializedType Py_IsInitialized;
	Py_FinalizeType Py_Finalize;
	PyRun_SimpleStringType PyRun_SimpleString;
	Py_SetProgramNameType Py_SetProgramName;
	PyImport_ImportModuleType PyImport_ImportModule;
	PyModule_GetDictType PyModule_GetDict;
	PyDict_SetItemStringType PyDict_SetItemString;
	PyObject_GetAttrStringType PyObject_GetAttrString;
	PyCObject_AsVoidPtrType PyCObject_AsVoidPtr;
	PyObject_AsCharBufferType PyObject_AsCharBuffer;
	PyObject_CallMethodType PyObject_CallMethod;

	PyObject *m_modcStringIO;
	PyObject *m_attrStr;
	PycStringIO_CAPI *m_objCAPI;
	PyObject *m_newBufObj;

	void Py_DECREF(PyObject *objPtr);

};

#endif // !defined(AFX_PYTHON_H__42B37617_72D1_4E20_9772_5018BD51AA96__INCLUDED_)
