// SelectFile.cpp : implementation file
//

#include "stdafx.h"
#include "urupython3.h"
#include "SelectFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelectFile dialog


CSelectFile::CSelectFile(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectFile::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectFile)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_mergePY = FALSE;
}


void CSelectFile::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectFile)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectFile, CDialog)
	//{{AFX_MSG_MAP(CSelectFile)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	ON_LBN_DBLCLK(IDC_LISTFILE, OnDblclkListfile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectFile message handlers

BOOL CSelectFile::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_listFont.CreatePointFont(80, _T("MS Sans Serif"), GetDC());


	// Fille list view
	CListBox *myList = (CListBox *)GetDlgItem(IDC_LISTFILE);
	myList->SetFont(&m_listFont);
	myList->ResetContent();
	myList->SetColumnWidth(200);
	CFileFind finder;
	CString pattern = m_sourceDir + _T("\\*.PYC"); 
	BOOL isFile = finder.FindFile(pattern);
	while (isFile) {
		isFile = finder.FindNextFile();

		int index = myList->AddString(finder.GetFileTitle());
		if (index >= 0) {
			// Select file if already in m_fileList
			if (IsFileInStr(finder.GetFileTitle(), m_fileList))
				myList->SetSel(index);
		}
	}
	finder.Close();
	

	if (m_mergePY) {
		pattern = m_sourceDir + _T("\\*.PY"); 
		isFile = finder.FindFile(pattern);
		while (isFile) {
			isFile = finder.FindNextFile();
			if (myList->FindString(-1, finder.GetFileTitle()) == LB_ERR) {
				int index = myList->AddString(finder.GetFileTitle());
				if (index >= 0) {
					// Select file if already in m_fileList
					if (IsFileInStr(finder.GetFileTitle(), m_fileList))
						myList->SetSel(index);
				}
			}
		}
		finder.Close();
	}
	
	GetDlgItem(IDC_LISTFILE)->SetFocus();

	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// Return TRUE if 'filetitle' is in 'listFile' (a comma separated list of file)
BOOL CSelectFile::IsFileInStr(CString filetitle, CString listFile)
{
	filetitle.TrimLeft();
	filetitle.TrimRight();
	filetitle.MakeUpper();

	listFile.TrimLeft();
	listFile.TrimRight();
	listFile.MakeUpper();

	if (filetitle.IsEmpty() || listFile.IsEmpty())
		return FALSE;

	int lengthFile = filetitle.GetLength();
	int lengthList = listFile.GetLength();
	int posStr = listFile.Find(filetitle);
	if (posStr < 0)
		return FALSE;

	do {
		if (posStr + lengthFile > lengthList)
			return FALSE;

		// There should be a comma after the name except if it's the end of the list
		if ((posStr + lengthFile == lengthList) || (listFile[posStr + lengthFile] == _T(','))) {
			// Now check for the comma at the beginning of the string (or it's the first character of the string)
			if ((posStr == 0) || (listFile[posStr - 1] == _T(',')))
				return TRUE;
		}

		posStr = listFile.Find(filetitle, posStr + 1);
	} while (posStr >= 0);

	return FALSE;
}

void CSelectFile::OnOK() 
{
	// Extract list of selected file
	m_fileList.Empty();
	CListBox *myList = (CListBox *)GetDlgItem(IDC_LISTFILE);
	int numSel = myList->GetSelCount();
	if (numSel > 0) {
		int *arrayInt = new int[numSel];

		int nbrItem = myList->GetSelItems(numSel, arrayInt);
		if (nbrItem > 0) {
			CString filetitle;
			for (int index = 0; index < nbrItem; index++) {
				if (index)
					m_fileList += _T(',');
				myList->GetText(arrayInt[index], filetitle);
				m_fileList += filetitle;
			}
		}

		delete arrayInt;
	}


	CDialog::OnOK();
}

// Select all item in a list
void CSelectFile::OnAll() 
{
	CListBox *myList = (CListBox *)GetDlgItem(IDC_LISTFILE);
	if (myList->GetCount())
		myList->SelItemRange(TRUE, 0, myList->GetCount() - 1);
}

void CSelectFile::OnDblclkListfile() 
{
	OnOK();
}
