// UnpackDiag.cpp : implementation file
//

#include "stdafx.h"
#include "UruPython3.h"
#include "UnpackDiag.h"
#include "FolderSelect.h"
#include "FilePak.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnpackDiag dialog


CUnpackDiag::CUnpackDiag(CWnd* pParent /*=NULL*/)
	: CDialog(CUnpackDiag::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUnpackDiag)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CUnpackDiag::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnpackDiag)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnpackDiag, CDialog)
	//{{AFX_MSG_MAP(CUnpackDiag)
	ON_BN_CLICKED(IDC_SELSOURCE, OnSelSource)
	ON_BN_CLICKED(IDC_SELDEST, OnSelDest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUnpackDiag message handlers

BOOL CUnpackDiag::OnInitDialog() 
{
	CDialog::OnInitDialog();

	GetDlgItem(IDC_SOURCE)->SetWindowText(g_config.pakFilename);
	GetDlgItem(IDC_DEST)->SetWindowText(g_config.srcFolder);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// Allows selection of source file
void CUnpackDiag::OnSelSource() 
{
	CString startPath;
	GetDlgItem(IDC_SOURCE)->GetWindowText(startPath);

	CFileDialog myOpenFile(TRUE, _T("pak"), startPath, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, 
													_T("PAK file (*.pak)|*.pak|All (*.*)|*.*||"), this);

	if (myOpenFile.DoModal() != IDOK)
		return;

	g_config.pakFilename = myOpenFile.GetPathName();
	GetDlgItem(IDC_SOURCE)->SetWindowText(g_config.pakFilename);

	// Create the destination folder based on the source file
	g_config.srcFolder = g_config.pakFilename;
	int posLastSlash = g_config.srcFolder.ReverseFind(_T('\\'));
	if (posLastSlash >= 0)
		g_config.srcFolder = g_config.srcFolder.Left(posLastSlash);
	g_config.srcFolder += _T("\\Src\\");
	GetDlgItem(IDC_DEST)->SetWindowText(g_config.srcFolder);
}

// Let user choose a destination folder
void CUnpackDiag::OnSelDest() 
{
	CString curFolder;
	GetDlgItem(IDC_DEST)->GetWindowText(curFolder);

	CFolderSelect mySelect;

	mySelect.m_dirName = curFolder;
	mySelect.m_MsgBrowse = _T("");
	if (mySelect.DoModal(this) == IDOK) {
		g_config.srcFolder = mySelect.m_dirName;
		GetDlgItem(IDC_DEST)->SetWindowText(g_config.srcFolder);
	}
}

// Try to unpack file before closing this dialog
void CUnpackDiag::OnOK() 
{
	CString destFolder;
	GetDlgItem(IDC_DEST)->GetWindowText(destFolder);

	CString sourceFilename;
	GetDlgItem(IDC_SOURCE)->GetWindowText(sourceFilename);

	// Make sure file exist
	CFileFind finder;
	BOOL fileExist = finder.FindFile(sourceFilename);
	finder.Close();

	if (!fileExist) {
		MessageBox(_T("Source file not found"), _T("File not found"), MB_ICONERROR);
		return;
	}

	// Create destination directory if it does not exist (must not have the last slash)
	CString tempFolder = destFolder.Left(destFolder.GetLength() - 1);
	fileExist = finder.FindFile(tempFolder);
	if (fileExist) {
		finder.FindNextFile();
		if (!finder.IsDirectory()) {
			MessageBox(_T("Destination must be a folder."), _T("Not a folder"), MB_ICONERROR);
			return;
		}
	}
	finder.Close();

	if (!fileExist) {
		// Try to create the directory
		if (!CreateDirectory(destFolder, NULL)) {
			MessageBox(_T("Unable to create destination folder."), _T("Error"), MB_ICONERROR);
			return;
		}
	}

	// Try to unpak the file
	CWaitCursor myWait;
	CString msgErr;
	int nbrFile;
	if (!g_filePak.UnpackFile(sourceFilename, destFolder, nbrFile, msgErr)) {
		CString msg;
		msg.Format(_T("Error while unpacking the file: %s"), msgErr);
		MessageBox(msg, _T("Error"), MB_ICONERROR);
		return;
	}

	CString msg;
	msg.Format(_T("%d files successfully unpacked"), nbrFile);
	MessageBox(msg, _T("Success"), MB_ICONEXCLAMATION);

	CDialog::OnOK();
}
