// UruPython3.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "UruPython3.h"
#include "UruPython3Dlg.h"

#include "BackPython.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CDataConfig g_config;

/////////////////////////////////////////////////////////////////////////////
// CUruPython3App

BEGIN_MESSAGE_MAP(CUruPython3App, CWinApp)
	//{{AFX_MSG_MAP(CUruPython3App)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
//	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUruPython3App construction

CUruPython3App::CUruPython3App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CUruPython3App object

CUruPython3App theApp;

/////////////////////////////////////////////////////////////////////////////
// CUruPython3App initialization

BOOL CUruPython3App::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	SetRegistryKey(_T("UruPython"));

	ReadReg();

	// Create background task that encapsulate Python interpreter
	g_backPython = new CBackPython;
	if (!g_backPython) {
		::MessageBox(NULL, _T("Unable to create Python background task.  Cannot continue"), NULL, MB_OK | MB_ICONERROR);
		return FALSE;
	}
	if (!g_backPython->CreateThread()) {
		::MessageBox(NULL, _T("Unable to create Python background task.  Cannot continue"), NULL, MB_OK | MB_ICONERROR);
		delete g_backPython;
		g_backPython = NULL;
		return FALSE;
	}
	g_backPython->m_bAutoDelete = FALSE;


	CUruPython3Dlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	SaveReg();

	// Destroy Python interpreter
	g_backPython->PostThreadMessage(WM_PYTHON_QUIT, 0, 0);
	::WaitForSingleObject(g_backPython->m_hThread, 3000);
	delete g_backPython;
	g_backPython = NULL;


	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

// List name of all variable stored in registry
const TCHAR *const RegKeyUruPath = _T("UruPath");
const TCHAR *const RegKeyUruExe = _T("UruExe");
const TCHAR *const RegKeyUruExeParam = _T("UruExeParam");
const TCHAR *const RegKeyPythonDLL = _T("PythonDLL");
const TCHAR *const RegKeyCompareDate = _T("CompareDate");
const TCHAR *const RegKeyLastEditName = _T("LastEditName");
const TCHAR *const RegKeyPakFilename = _T("PakFilename");
const TCHAR *const RegKeySrcFolder = _T("SrcFolder");
const TCHAR *const RegKeyCompile = _T("Compile");
const TCHAR *const RegKeyRunUru = _T("RunUru");

// Read config parameter from registry
void CUruPython3App::ReadReg()
{
	// Extract UruPython.exe path
	TCHAR curDir[8192];
	if (GetModuleFileName(NULL, curDir, sizeof(curDir))) {
		g_config.appPath = curDir;
		// Get rid of "UruPython.exe" from the path name
		int posLastSlash = g_config.appPath.ReverseFind(_T('\\'));
		if (posLastSlash >= 0) {
			g_config.appPath = g_config.appPath.Left(posLastSlash + 1);		// Keep last slash
		} else
			g_config.appPath.Empty();		// Strange...No slash in path ...
	} else {
		g_config.appPath.Empty();
	}

	g_config.uruPath = GetProfileString(_T(""), RegKeyUruPath, _T("C:\\Program Files\\Ubi Soft\\Cyan Worlds\\Uru - Ages Beyond Myst\\"));
	g_config.pakFilename = GetProfileString(_T(""), RegKeyPakFilename, g_config.uruPath + _T("Python\\Python.pak"));
	g_config.srcFolder = GetProfileString(_T(""), RegKeySrcFolder, g_config.uruPath + _T("Python\\Src\\"));
	g_config.uruExe = GetProfileString(_T(""), RegKeyUruExe, _T("UruSetup.exe"));
	g_config.uruExeParam = GetProfileString(_T(""), RegKeyUruExeParam, _T("SinglePlayer"));
	g_config.pythonDLL = GetProfileString(_T(""), RegKeyPythonDLL, _T("cypython22.dll"));
	g_config.lastEditName = GetProfileString(_T(""), RegKeyLastEditName, _T("xKI"));

	g_config.compareDate = GetProfileInt(_T(""), RegKeyCompareDate, 1);
	g_config.compile = GetProfileInt(_T(""), RegKeyCompile, 1);
	g_config.runUru = GetProfileInt(_T(""), RegKeyRunUru, 1);
}

// Write config data to registry
void CUruPython3App::SaveReg()
{
	WriteProfileString(_T(""), RegKeyUruPath, g_config.uruPath);
	WriteProfileString(_T(""), RegKeyUruExe, g_config.uruExe);
	WriteProfileString(_T(""), RegKeyUruExeParam, g_config.uruExeParam);
	WriteProfileString(_T(""), RegKeyPythonDLL, g_config.pythonDLL);
	WriteProfileString(_T(""), RegKeyLastEditName, g_config.lastEditName);
	WriteProfileString(_T(""), RegKeyPakFilename, g_config.pakFilename);
	WriteProfileString(_T(""), RegKeySrcFolder, g_config.srcFolder);

	WriteProfileInt(_T(""), RegKeyCompareDate, g_config.compareDate);
	WriteProfileInt(_T(""), RegKeyCompile, g_config.compile);
	WriteProfileInt(_T(""), RegKeyRunUru, g_config.runUru);
}


// Count number of comma
int CountComma(CString text)
{
	int nbrComma = 0;
	int posComma = text.Find(_T(','));
	if (posComma >= 0) {
		nbrComma++;
		while ((posComma = text.Find(_T(','), posComma + 1)) >= 0)
			nbrComma++;
	}
	return nbrComma;
}
