// UruPython3Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "UruPython3.h"
#include "UruPython3Dlg.h"
#include "ConfigDiag.h"
#include "UnpackDiag.h"
#include "DecompyleDiag.h"
#include "BackPython.h"
#include "EditFile.h"
#include "PakFilesDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUruPython3Dlg dialog

CUruPython3Dlg::CUruPython3Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUruPython3Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUruPython3Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUruPython3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUruPython3Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUruPython3Dlg, CDialog)
	//{{AFX_MSG_MAP(CUruPython3Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONFIG, OnConfig)
	ON_BN_CLICKED(IDC_UNPACK, OnUnpack)
	ON_BN_CLICKED(IDC_DECOMP, OnDecomp)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_BN_CLICKED(IDC_PACK, OnPack)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUruPython3Dlg message handlers

BOOL CUruPython3Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUruPython3Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUruPython3Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUruPython3Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUruPython3Dlg::OnCancel() 
{
	if (MessageBox(_T("Do you want to quit?"), _T("Confirmation"), MB_YESNOCANCEL | MB_DEFBUTTON1 | MB_ICONQUESTION) != IDYES)
		return;
	
	CDialog::OnCancel();
}

// Open config windows
void CUruPython3Dlg::OnConfig() 
{
	CConfigDiag config;
	config.DoModal();

}

void CUruPython3Dlg::OnUnpack() 
{
	CUnpackDiag unpackDiag;
	unpackDiag.DoModal();
}

void CUruPython3Dlg::OnDecomp() 
{
	// Make sure python interpreter is started
	if (!g_backPython->IsPythonStarted()) {
		CString msgErr;
		if (!g_backPython->StartPython(msgErr)) {
			CString msg;
			msg.Format(_T("Unable to start python => [%s].  Press Config and Fetch DLL if not done yet."));
			MessageBox(msg, _T("Error"), MB_ICONERROR);
			return;
		}
	}

	CDecompyleDiag myDiag;
	myDiag.DoModal();
}

void CUruPython3Dlg::OnEdit() 
{
	CString startPath = g_config.srcFolder + g_config.lastEditName + _T(".py");

	CFileDialog myOpenFile(TRUE, _T("py"), startPath, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, 
													_T("Python source (*.py)|*.py|All (*.*)|*.*||"), this);

	if (myOpenFile.DoModal() != IDOK)
		return;

	g_config.lastEditName = myOpenFile.GetFileTitle();

	CEditFile myEdit;
	myEdit.m_filename = myOpenFile.GetPathName();
	myEdit.DoModal();

}

void CUruPython3Dlg::OnPack() 
{
	CPakFilesDlg myDiag;
	myDiag.DoModal();
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	GetDlgItem(IDC_EDIT1)->SetWindowText(_T("This program let you edit Python script used in Uru.\r\n")
																			 _T("It has been created by a Uru fan.\r\n")
																			 _T("It is not approved/authorized by Ubisoft or Cyan.\r\n")
																			 _T("Don't ask them for any support concerning this program.\r\n")
																			 _T("You may find some support at www.clockworkorangebbs.org in the H'Uru forum"));

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
